module type S = sig
  type 'a t
  (** type d'une collection *)

  val empty : unit -> 'a t
  (** création d'une collection vide *)

  val push : 'a t -> 'a -> unit
  (** ajout d'une valeur à la collection *)

  val pop : 'a t -> 'a
  (** retire une valeur à la collection. Lève une exception failwith "..." si la
    collection est vide. *)

  val peek : 'a t -> 'a
  (** renvoie la prochaine valeur de la collection, sans la retirer.
      Lève une exception failwith "..." si la collection est vide.
  *)

  val size : 'a t -> int
  (** renvoie la taille de la collection *)

  val iter : ('a -> unit) -> 'a t -> unit
  (** applique la fonction donnée à tous les éléments de la collection sans les
    retirer. *)
end
